#Include <File.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>


Global $IniFile=@ScriptDir & "\word2imp.ini"
Global $OpenedFileName, $OpenedFile, $OpenedFileExtension, $OpenedFileNoExtension
Global $BuildTarget
Global $Process_ID=""

$MainForm = GUICreate("Word2IMP", 291, 189, -1, -1)
$Convert = GUICtrlCreateButton("Convert", 216, 140, 65, 25, 0)
$Author = GUICtrlCreateInput("", 55, 15, 225, 21)
$Title = GUICtrlCreateInput("", 55, 45, 225, 21)
$Category = GUICtrlCreateInput("", 55, 75, 225, 21)
$AutorLabel = GUICtrlCreateLabel("Author:", 17, 18, 38, 15)
$TitleLabel = GUICtrlCreateLabel("Title:", 28, 48, 27, 15)
$CategoryLabel = GUICtrlCreateLabel("Category:", 6, 78, 47, 15)
$BuildTargetGroup = GUICtrlCreateGroup("Build target", 6, 106, 148, 58)
	$TargetETI = GUICtrlCreateRadio("ETI(epub)", 10, 120, 68, 20)
	$TargetREB1200 = GUICtrlCreateRadio("REB1200", 10, 140, 68, 20)
	$TargetEBW1150 = GUICtrlCreateRadio("EBW1150", 85, 120, 68, 20)
	$TargetREB1100 = GUICtrlCreateRadio("REB1100", 85, 140, 68, 20)
$Messages = GUICtrlCreateLabel("", 160, 112, 200, 15)
$FileMenu = GUICtrlCreateMenu("&File")
$FileOpenItem = GUICtrlCreateMenuItem("Open", $FileMenu)
$FileExitItem = GUICtrlCreateMenuItem("Exit", $FileMenu)

GUISetState(@SW_SHOW,$MainForm)
;GUICtrlSetState($Messages, $GUI_HIDE)

ReadWord2Imp_ini_BuildTarget()
While 1
	$nmsg = GUIGetMsg()
	If $nmsg = $FileOpenItem Then
		$LastDir = IniRead($IniFile,"dir","lastdir",@MyDocumentsDir)
			$OpenedFileName = FileOpenDialog("Choose file...", $LastDir, "All (*.*)")
			If @error <> 1 Then
				LastDir()
				GUICtrlSetData($Author,$OpenedFileNoExtension)
				GUICtrlSetData($Title,$OpenedFileNoExtension)
				GUICtrlSetState($Messages, $GUI_SHOW)
				GUICtrlSetData($Messages, "File ready for conversion...")
			EndIf
	EndIf
	If $nmsg = $Convert Then 
		If $OpenedFileName <> "" Then 
				Conversion()
			Else 
				MsgBox(0, "","Nothing to convert!")
			EndIf
	EndIf
	If $nmsg = $TargetETI Or $nmsg = $TargetREB1200 Or $nmsg = $TargetEBW1150 Or $nmsg = $TargetREB1100 Then
		$BuildTarget = $nmsg - $TargetETI
		EndIf
	;If $nmsg = $TargetETI And BitAND(GUICtrlRead($TargetETI), $GUI_CHECKED) = $GUI_CHECKED Then $BuildTarget=0
	;If $nmsg = $TargetREB1200 And BitAND(GUICtrlRead($TargetREB1200), $GUI_CHECKED) = $GUI_CHECKED Then $BuildTarget=1
	;If $nmsg = $TargetEBW And BitAND(GUICtrlRead($TargetEBW1150), $GUI_CHECKED) = $GUI_CHECKED Then $BuildTarget=2	
	;If $nmsg = $TargetREB1100 And BitAND(GUICtrlRead($TargetREB1100), $GUI_CHECKED) = $GUI_CHECKED Then $BuildTarget=3
	$Msg_from_process = StdoutRead($Process_ID)
	If $Msg_from_process <> "" and StringLeft($Msg_from_process,1) <> "M" Then
    GUICtrlSetData($Messages, $Msg_from_process)
	EndIf
	If $nmsg=$FileExitItem Or $nmsg = $GUI_EVENT_CLOSE Then Exitloop
WEnd
IniWrite($IniFile,"buildtarget","BuildTarget",$BuildTarget)
GUIDelete()
Exit
Func ReadWord2Imp_ini_BuildTarget()
	$BuildTarget = IniRead($IniFile,"buildtarget","BuildTarget",2)
	Switch $BuildTarget
		Case 0
			GUICtrlSetState($TargetETI,$GUI_CHECKED)
		Case 1
			GUICtrlSetState($TargetREB1200,$GUI_CHECKED)
		Case 2
			GUICtrlSetState($TargetEBW1150,$GUI_CHECKED)
		Case 3
			GUICtrlSetState($TargetREB1100,$GUI_CHECKED)
	EndSwitch
	EndFunc

Func LastDir()
	dim $LastDir1,$LastDir2
	_PathSplit($OpenedFileName,$LastDir1,$LastDir2,$OpenedFileNoExtension,$OpenedFileExtension)
	$LastDir=$LastDir1 & $LastDir2
IniWrite($IniFile,"dir","lastdir",$LastDir)
	EndFunc

Func Conversion()
$Process_ID = Run(@ComSpec & " /c " & "cscript " & @ScriptDir & "\word2imp.js """ & $OpenedFileName & """ """ & GUICtrlRead($Author) & """ """ & GUICtrlRead($Title) & """ """ & GUICtrlRead($Category) & """ " & $BuildTarget, "", @SW_HIDE, $STDERR_CHILD + $STDOUT_CHILD)
	EndFunc
